from math import sqrt


class Point:
    def __init__(self, x: int, y: int):
        self.x = x
        self.y = y


class Circle:
    def __init__(self, c: Point, r: int):
        self.c = c
        self.r = r


class Rectangle:
    def __init__(self, a: Point, b: Point):
        self.a = Point(min(a.x, b.x), max(a.y, b.y))
        self.b = Point(max(a.x, b.x), max(a.y, b.y))
        self.c = Point(min(a.x, b.x), min(a.y, b.y))
        self.d = Point(max(a.x, b.x), min(a.y, b.y))


def dst(a: Point, b: Point):
    return sqrt((a.x - b.x) ** 2 + (a.y - b.y) ** 2)


cX, cY, R, Ax, Ay, Bx, By = input().split()
C = Circle(Point(cX, cY), R)
R = Rectangle(Point(Ax, Ay), Point(Bx, By))

# circle inside rect
if dst(C.c, R.a) < C.r and dst(C.c, R.b) < C.r and dst(C.c, R.c) < C.r and dst(C.c, R.d) < C.r:
    pass

# circle outside rect
elif dst(C.c, R.a) > C.r and dst(C.c, R.b) > C.r and dst(C.c, R.c) > C.r and dst(C.c, R.d) > C.r:
    pass

# top part of circle in rect
elif dst(C.c, R.c) >= C.r and dst(C.c, R.d) >= C.r and R.c.y > (C.c.y + C.r)